#!/bin/bash
# Check for various device setup to save settings
# Called from exit.lua
# (c) Robert Shingledecker 2006-2007
. /etc/init.d/dsl-functions


CMDLINE="$(cat /proc/cmdline)"
MYDSLDIR="$(realpath `cat /opt/.mydsl_dir`)"
ACTION="$1"
CHK_BACKUP="$2"

if [ "$CHK_BACKUP" == "yes" ] && [ ! -s /opt/.backup_device ]; then
   popup.lua 'Attention! Requete de sauvegarde des reglages du systeme.
Mais pas de peripherique de sauvegarde selectionne!
Veuillez Utiliser le panneau de configuration pour le selectionner.
Arret du systeme interrompu!'
   exit 1
fi      

if [ -e /KNOPPIX/bin/ash ]; then
  if [ -e /tmp/printer.flag ]; then
    if [ -z "$(grep apsfilter /opt/.filetool.lst)" ]; then
      ANS=`popask.lua 'Tentative de reglage imprimante. Votre imprimante est-elle en fonction et connectee? Sauvegarde des reglages?'`
      if [ "$ANS" == 1 ]; then
         sed -i '$s~$~\nopt/printcap\nopt/apsfilter/\nvar/spool/lpd/~' /opt/.filetool.lst
         sed -i '$s~$~\n/usr/sbin/lpd~' /opt/bootlocal.sh
         CHK_BACKUP="yes"
      fi
    fi
  fi
fi

/usr/local/bin/umix -sf "$HOME"/.umix

if [ -s /opt/.backup_device ]; then 
aterm +tr -bg white -fg black -geometry 80x2 -e filetool.sh backup noprompt
if [ -s /tmp/backup_status ]; then
   popup.lua 'Fatal! La sauvegarde ne se termine pas normalement.
Veuillez corriger avant arret du systeme.
Veuillez effacer les donnees de volume trop important et re-essayez. 
Arret du systeme interrompu!'
   exit 1
fi      
fi

# remove MyDSL shortcuts/icons

for F in `ls -1 /tmp/mydsl.installed`; do
 for S in `cat /tmp/mydsl.installed/$F`; do
   sudo rm "$MYDSLDIR"/"$F" 2>/dev/null
 done
done
sudo rm -f "$MYDSLDIR"/*.app 2>/dev/null
sed -i '/mydsl.icons/d' /opt/.dfmext
/usr/bin/cleanIcons.lua

# remove MyDSL mounts
if [ -f /tmp/mydsl.map ]; then
   for LINE in `grep -v "^free" /tmp/mydsl.map`
   do
      sudo /etc/init.d/mountci "$LINE" shutdown
   done
fi
# finally remove the icon/shortcut list
sudo rm -rf /tmp/mydsl.installed/*
sudo rm -rf /tmp/mydsl.menu/*

case "$ACTION" in
  reboot )
    sudo shutdown -r now
  ;;
  shutdown )
    sudo shutdown -h now
  ;;
  * )
    sudo shutdown -h now
  ;;
esac
