#!/bin/lua

-- (c) 2005,2006 Robert Shingledecker
-- Icon Tool
-- Tab3 Icon Images by mikshaw
require("fltk")

dofile("/etc/init.d/functions5.lua")

window_width = 310
window_height = 350
view_port = window_height-25

lnk_table = {}
listname = os.tmpname()

w = fltk:Fl_Double_Window(window_width,window_height,"Outil Icones DSL")
tabs = fltk:Fl_Tabs(0,0,window_width,window_height)
tabs:box(fltk.FL_THIN_UP_BOX)
tabs:selection_color(fltk.FL_GREEN)

tab1 = fltk:Fl_Group(0,0,window_width,view_port,"Cliquer")

iconGroup = fltk:Fl_Group(0,0,window_width,125)
iconsBtn = fltk:Fl_Light_Button(50,50,200,40,"Voir les Icones")
iconsBtn:type(fltk.FL_RADIO_BUTTON)
iconsBtn:value(1)
clickValue = 0
iconsBtn:callback(
function(iconsBtn)
  singleClickBtn:value(1)
  clickValue = 0
end)

noIconsBtn = fltk:Fl_Light_Button(50,100,200,40,"Pas d'Icones")
noIconsBtn:type(fltk.FL_RADIO_BUTTON)
noIconsBtn:callback(
function(noIconsBtn)
  singleClickBtn:value(0)
  doubleClickBtn:value(0)
  clickValue = 0
end)  
fltk:Fl_End()  -- End iconGroup Layout

clickGroup = fltk:Fl_Group(0,125,window_width,320)
singleClickBtn = fltk:Fl_Light_Button(50,150,200,40,"Un seul Click")
singleClickBtn:type(fltk.FL_RADIO_BUTTON)
singleClickBtn:value(1)
clickValue = 0
singleClickBtn:callback(
function(singleClickBtn)
  clickValue = 0
end)

doubleClickBtn = fltk:Fl_Light_Button(50,200,200,40,"Double Click")
doubleClickBtn:type(fltk.FL_RADIO_BUTTON)
doubleClickBtn:callback(
function(doubleClickBtn)
  clickValue = 500
end)
fltk:Fl_End() -- End clickGroup Layout

ok = fltk:Fl_Button(120,view_port-35,50,25,"&OK")
ok:shortcut('o')
ok:callback(
function(ok)
 if iconsBtn:value() == 1 then
   updateLine(".xtdesktop/xtdeskrc","ClickInterval","  ClickInterval: "..clickValue)
   updateLine(".desktop","icons","icons: 1")
   os.execute("iconsnap.sh")
 else
   updateLine(".desktop","icons","icons: 0")
   os.execute("killall -9 xtdesk >/dev/null 2>&1")
 end
 os.exit(0)
end)

fltk:Fl_End() -- End tab1 Layout

tab2 = fltk:Fl_Group(0,0,window_width,view_port,"Organisation")

btnGroup = fltk:Fl_Group(0,0,window_width,125)
manualBtn = fltk:Fl_Light_Button(15,20,280,40,"Utiliser les coordonnees X/Y")
manualBtn:type(fltk.FL_RADIO_BUTTON)
manualBtn:callback(
function(manualBtn)
  autoArrangeBtn:value(0)
  manualBtn:value(1)
  autoArrange = 0
  autoArrangeGroup:hide()
  manualArrangeGroup:show()
end)

autoArrangeBtn = fltk:Fl_Light_Button(15,80,280,40,"Disposition automatique:")
autoArrangeBtn:type(fltk.FL_RADIO_BUTTON)
autoArrangeBtn:value(1)
autoArrange = 1
autoArrangeBtn:callback(
function(autoArrangeBtn)
  autoArrangeBtn:value(1)
  manualBtn:value(0)
  autoArrange = 1
  autoArrangeGroup:show()
  manualArrangeGroup:hide()
end)
fltk:Fl_End() -- End btnGroup Layout

manualArrangeGroup = fltk:Fl_Group(0,125,window_width,view_port)
manualMsgBox = fltk:Fl_Box(20,140,window_width-40, view_port-160)
manualMsgBox:box(fltk.FL_ENGRAVED_BOX)
manualMsgBox:label(
[[Instructions:

Pour regler la position X/Y des icones,

clic-droit sur le bureau => "Proprietes",

puis utilisez l'editeur pour entrer

les coordonnees X/Y de chaque icone.
]])
fltk:Fl_End() -- End manualArrangeBox
manualArrangeGroup:hide()

autoArrangeGroup = fltk:Fl_Group(0,125,window_width,view_port-35)
cols_input = fltk:Fl_Input(120,view_port-175,50,25,"Colonnes:")
cols_input:value(4)
cols_down = fltk:Fl_Button(180,view_port-175,25,25,"@<")
cols_down:callback(
function(cols_down)
  cols_input:value(cols_input:value() - 1)
end)
cols_up = fltk:Fl_Button(210,view_port-175,25,25,"@>")
cols_up:callback(
function(cols_up)
  cols_input:value(cols_input:value() + 1)
end)

margin_input = fltk:Fl_Input(120,view_port-145,50,25,"Marge du haut:")
margin_input:value(5)
margin_down = fltk:Fl_Button(180,view_port-145,25,25,"@<")
margin_down:callback(
function(margin_down)
  margin_input:value(margin_input:value() - 1)
end)
margin_up = fltk:Fl_Button(210,view_port-145,25,25,"@>")
margin_up:callback(
function(margin_up)
  margin_input:value(margin_input:value() + 1)
end)

horz_input = fltk:Fl_Input(120,view_port-115,50,25,"Horizontal:")
horz_input:value(65)
horz_down = fltk:Fl_Button(180,view_port-115,25,25,"@<")
horz_down:callback(
function(horz_down)
  horz_input:value(horz_input:value() - 1)
end)
horz_up = fltk:Fl_Button(210,view_port-115,25,25,"@>")
horz_up:callback(
function(horz_up)
  horz_input:value(horz_input:value() + 1)
end)

vert_input = fltk:Fl_Input(120,view_port-85,50,25,"Vertical:")
vert_input:value(76)
vert_down = fltk:Fl_Button(180,view_port-85,25,25,"@<")
vert_down:callback(
function(vert_down)
  vert_input:value(vert_input:value() - 1)
end)
vert_up = fltk:Fl_Button(210,view_port-85,25,25,"@>")
vert_up:callback(
function(vert_up)
  vert_input:value(vert_input:value() + 1)
end)

ok = fltk:Fl_Button(120,view_port-35,50,25,"&OK")
ok:shortcut('o')
ok:callback(
function(ok)
 local filein,err = io.open(".xtdesktop/xtdeskrc","r")
 if not filein then
   fltk.fl_alert("Ouverture impossible de xtdeskrc! "..err)
   os.exit(1)
 end
 local data={}
 for line in filein:lines() do data[#data +1]=line end
 filein:close()
 local fileout,err = io.open(".xtdesktop/xtdeskrc","w")
 if not fileout then
   fltk:fl_alert("Ouverture impossible de xtdeskrc!")
   os.exit(1)
 end
 for i = 1, #data do
   line = data[i]
   if string.find(line,"Cols:") then
      if autoArrange == 0 then cols_input:value(0) end
      line = "  Cols: "..cols_input:value()
   end
   if autoArrange == 1 then
      if string.find(line,"Width:") then
         line = "  Width: "..horz_input:value()
      end
      if string.find(line,"Height:") then
         line = "  Height: "..vert_input:value()
      end
      if string.find(line,"TopMargin:") then
         line = "  TopMargin: "..margin_input:value()
      end
   end
   fileout:write(line.."\n")
 end
 fileout:close()
 os.execute("iconsnap.sh")
 os.exit(0)
end)

fltk:Fl_End() -- autoArrangeGroup Layout

fltk:Fl_End() -- End tab2 Layout

tab3 = fltk:Fl_Group(0,0,window_width,view_port,"Ajouter")

function iconpickme(self)
 selected_item = self:tooltip()
 print(self:tooltip())
end

fltk.fl_register_images()
iconscroll = fltk:Fl_Scroll(0,0,310,225); fltk:Fl_End()
iconpack = fltk:Fl_Pack(0,0,290,225); fltk:Fl_End()
iconscroll:add(iconpack)
iconbuttons={}

icondir=".xtdesktop/"
icondirlist = readDir(icondir)
for i,v in ipairs(icondirlist) do
 icontmp=string.lower(v)
 if string.find(icontmp,"%.png$") or
    string.find(icontmp,"%.jpe?g$") or
    string.find(icontmp,"%.xpm$") or
    string.find(icontmp,"%.gif$")
 then
   iconimage=Fl_Shared_Image.get(icondir..v)
   iconbuttons[i]=fltk:Fl_Radio_Light_Button(0,0,200,75)
   iconbuttons[i]:image(iconimage)
   iconbuttons[i]:label(v.."  "..iconimage:w().."x"..iconimage:h())
   iconbuttons[i]:tooltip(icondir..v)
   iconbuttons[i]:align(84)
   iconbuttons[i]:callback(iconpickme)
   iconpack:add(iconbuttons[i])
 end
end

iconLabel_input = fltk:Fl_Input(80,230,100,25,"Label.icone:")
iconX_input = fltk:Fl_Input(200,230,40,25,"X:")
iconY_input = fltk:Fl_Input(260,230,40,25,"Y:")
fullPath_input = fltk:Fl_Input(80,260,220,25,"Chemin:")

addOk = fltk:Fl_Button(120,view_port-35,50,25,"&OK")
addOk:shortcut('o')
addOk:callback(
function(addOk)
  if selected_item == nil then
     fltk.fl_alert("Un choix d'icone est requis!")
     return
  end
  if iconLabel_input:value() == "" then
     fltk.fl_alert("Un label est requis!")
     return
  end
  if string.find(iconLabel_input:value()," ") then
     fltk.fl_alert("Pas d'espace dans le label!")
     return
  end
  if string.find(iconLabel_input:value(),"/") then
     fltk.fl_alert("Pas de / dans le label!")
     return
  end
  if fullPath_input:value() == "" then
     fltk.fl_alert("Chemin complet vers l'application requis!")
     return
  end
  if iconX_input:value() == "" then iconX_input:value(0) end
  if iconY_input:value() == "" then iconY_input:value(0) end
  local fileout,err = io.open(".xtdesktop/"..iconLabel_input:value()..".lnk","w")
  if not fileout then
     fltk.fl_alert("Ouverture impossible "..iconLabel_input:value())
     os.exit(1)
  end
  fileout:write("table Icon\n")
  fileout:write(" Type: Program\n")
  fileout:write(" Caption: "..iconLabel_input:value().."\n")
  fileout:write(" Command: "..fullPath_input:value().."\n")
  fileout:write(" Icon: "..selected_item.."\n")
  fileout:write(" X: "..iconX_input:value().."\n")
  fileout:write(" Y: "..iconY_input:value().."\n")
  fileout:write(" Status: anchor\n")
  fileout:write("end\n")
  fileout:close()
  os.execute("iconsnap.sh")
  os.exit(0)
end)

helpBtn = fltk:Fl_Button(250,view_port-35,50,25,"Aide")
helpBtn:callback(
function(helpBtn)
  fltk.fl_message("1. Selectionner une Icone.\n2. Entrer un Label pour l'Icone\n3. Entrer la position X & Y.\n4. Entrer le chemin complet vers l'application.")
end)

--** selector:position(0)
fltk:Fl_End()  -- End tab3 Layout

tab4 = fltk:Fl_Group(0,0,window_width,view_port,"Effacer")

os.execute('ls -1 .xtdesktop/*.lnk >'..listname)

selector = fltk:Fl_Hold_Browser(0,0,310,280)
selector:callback(
function(selector)
  selected_item = selector:text(selector:value())
  selected_index = selector:value()
end)
if not selector:load(listname) then
  print("Chargement impossible ", listname)
  os.exit(1)
end

delOk = fltk:Fl_Button(120,view_port-35,50,25,"&OK")
delOk:shortcut('o')
delOk:callback(
function(delOk)
  if selected_item == nil then
     fltk.fl_alert("Vous devez choisir un item!")
  else
     selector:remove(selected_index)
     base_item = tailString(selected_item,"/")
     if os.execute("ls /etc/skel/.xtdesktop/"..base_item.." 2>/dev/null")~=0 then
        os.remove(selected_item)
     else
        os.rename(selected_item,selected_item..".hide")
     end
     os.execute("iconsnap.sh")
     selected_item = nil
  end
end)

helpBtn = fltk:Fl_Button(250,view_port-35,50,25,"Aide")
helpBtn:callback(
function(helpBtn)
  fltk.fl_message("Selectionner le fichier lnk a effacer.\n Appuyez le bouton Effacer.")
end)

selector:position(0)

fltk:Fl_End() -- End tab4 Layout

fltk:Fl_End() -- End tabs Layout

w:resizable(w)
w:show()
Fl:run()
